import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * De bulldozer die de kisten verschuift.
 */
public class Bulldozer extends Beweger {
    private int leeftijd;
    
    private boolean inBeweging;
    
    public Bulldozer() {
        this.leeftijd = 0;
        this.inBeweging = false;
    }
    
    private Kist kist; // kist die eventueel moet meeschuiven met de bulldozer
    
    private boolean kanBewegen(int richting) {
        Actor buur = buur(richting);
        this.kist = null;
        if (buur == null) {
            return true;
        } else if (buur instanceof Kist) {
            this.kist = (Kist)buur;
            return kist.kanBewegen(richting);
        } else {
            return false;
        }
    }
    
    
    public static final String[] TOETSNAMEN = { "right", "down", "left", "up" };
    
    /**
     * Bepaal de nieuwe richting aan de hand van een ingedrukte toets en
     * de buren in de opgegeven richting
     */
    private void bepaalNieuweRichting() {
       int r = 0;
       while (r < 4 && !Greenfoot.isKeyDown(TOETSNAMEN[r])) {
           r ++;
       }       
       if (r == 4) {       
           inBeweging = false; // geen toets ingedrukt
       } else {
           inBeweging = kanBewegen(90*r);
           setRotation(90*r);
        }
    }
    
    
    public void act() {
        // teken 
        setImage ("bulldozer-" + (leeftijd % 2) + ".png");
        
        if (getX()%4 == 2  && getY()%4 == 2) {
            // alleen als het voorwerp zich precies in een cel bevindt
            bepaalNieuweRichting();            
        }
            
        if (inBeweging) {             
            leeftijd++;
            move(1);    
            if (kist != null) {
                kist.verschuif(getRotation());
            }     
        }   
    }    
}
