import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Vloer waarop alles gebeurt.
 */
public class Vloer extends World {
    
    /* alternatieve kaart
    
    private static final String[] KAART = {
        "OOOOOO  OOO ",
        "O..  O OOsOO",
        "O..  OOO   O",
        "O..     xx O",
        "O..  O O x O",
        "O..OOO O x O",
        "OOOO x Ox  O",
        "   O  xO x O",
        "   O x  x  O",
        "   O  OO   O",
        "   OOOOOOOOO" 
    };
    */
   
    private static final String[] KAART = {
        "OOOOOOOOOOOO  ",
        "O..  O     OOO",
        "O..  O x  x  O",
        "O..  OxOOOO  O",
        "O..    s OO  O",
        "O..  O O  x OO",
        "OOOOOO OOx x O",
        "  O x  x x x O",
        "  O    O     O",
        "  OOOOOOOOOOOO" 
    };
   
    /**
     * Creëer een vloer en vul hem op met objecten zoals op de kaart.
     */
    public Vloer() {    
        // We laten de grootte van de wereld afhangen van de kaart
        super(KAART[0].length()*4+2, KAART.length*4+2, 8); 
        
        Greenfoot.setSpeed (33);
        
        setPaintOrder (Bulldozer.class, Kist.class, Doel.class);
        
        for (int rij=0; rij < KAART.length; rij++) {
            String lijn = KAART[rij];
            for (int kol=0; kol < lijn.length(); kol++) {
               char code = lijn.charAt(kol);
               int x = 4*kol + 2;
               int y = 4*rij + 2;
               if (code == 'O') {
                   addObject (new Muur(), x, y);
               } else if (code == '.') {
                   addObject (new Doel(), x, y);
               } else if (code == 'x') {
                   addObject (new Kist(), x, y);
               } else if (code == 's') {
                   addObject (new Bulldozer(), x, y);
               }
            }
        }
    }
}
